<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>iipsrv: Watermark.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="iip.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">iipsrv
   &#160;<span id="projectnumber">1.1</span>
   </div>
   <div id="projectbrief">iipsrv is an advanced high-performance feature-rich image server for web-based streamed viewing and zooming of ultra high-resolution images</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('Watermark_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Watermark.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">    IIPImage Server - Watermark Class</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">    Enables dynamic watermarking of images with user-defined opacity and</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">    random positioning within the image.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">    Development supported by Moravian Library in Brno (Moravska zemska</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">    knihovna v Brne, http://www.mzk.cz/) R&amp;D grant MK00009494301 &amp; Old</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">    Maps Online (http://www.oldmapsonline.org/) from the Ministry of</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">    Culture of the Czech Republic.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">    Copyright (C) 2010-2013 Ruven Pillay.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">    This program is free software; you can redistribute it and/or modify</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">    it under the terms of the GNU General Public License as published by</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">    the Free Software Foundation; either version 3 of the License, or</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">    (at your option) any later version.</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">    This program is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">    GNU General Public License for more details.</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">    You should have received a copy of the GNU General Public License</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment">    along with this program; if not, write to the Free Software Foundation,</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#ifndef _WATERMARK_H</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#define _WATERMARK_H</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classWatermark.html">   41</a></span>&#160;<span class="keyword">class </span><a class="code" href="classWatermark.html">Watermark</a> {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; <span class="keyword">private</span>:</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _width;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _height;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _channels;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _bpc;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;  std::string _image;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;  <span class="keywordtype">float</span> _opacity;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="keywordtype">float</span> _probability;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  <span class="keywordtype">bool</span> _isSet;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>* _watermark;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; <span class="keyword">public</span>:</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="classWatermark.html#a274317a27cb523b519b28be6d622f2bf">   76</a></span>&#160;  <a class="code" href="classWatermark.html#a274317a27cb523b519b28be6d622f2bf">Watermark</a>(){</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    _isSet=<span class="keyword">false</span>;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    _watermark = NULL;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    _opacity = 0.0;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    _probability = 0.0;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;  };</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classWatermark.html#a96a43470184588ea58d0b529213a7ec7">   88</a></span>&#160;  <a class="code" href="classWatermark.html#a96a43470184588ea58d0b529213a7ec7">Watermark</a>( <span class="keyword">const</span> std::string&amp; file, <span class="keywordtype">float</span> opacity, <span class="keywordtype">float</span> probability ){</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    _image = file;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    _width = 0;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    _height = 0;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    _channels = 0;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    _bpc = 0;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    _opacity = opacity;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    _probability = probability;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    _isSet = <span class="keyword">false</span>;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    _watermark = NULL;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;  };</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classWatermark.html#a5e484cce31c3d67dceb751df8e48a8ef">  101</a></span>&#160;  <a class="code" href="classWatermark.html#a5e484cce31c3d67dceb751df8e48a8ef">~Watermark</a>(){</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">if</span>( _watermark ) <span class="keyword">delete</span>[] _watermark;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;  };</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classWatermark.html#a32e861948948b0ef070cb1a60439f58f">apply</a>( <span class="keywordtype">void</span>* data, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> channels, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bpc );</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="classWatermark.html#af18c0054dceec80c7ab1a5d2c8d10967">  115</a></span>&#160;  std::string <a class="code" href="classWatermark.html#af18c0054dceec80c7ab1a5d2c8d10967">getImage</a>(){ <span class="keywordflow">return</span> _image; };</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="classWatermark.html#a497b6518f7470e5048bb6be853d4f85e">  118</a></span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classWatermark.html#a497b6518f7470e5048bb6be853d4f85e">getOpacity</a>(){ <span class="keywordflow">return</span> _opacity; };</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="classWatermark.html#a7fe56ff07579dc3b432dc6daa699f25c">  121</a></span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classWatermark.html#a7fe56ff07579dc3b432dc6daa699f25c">getProbability</a>(){ <span class="keywordflow">return</span> _probability; };</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classWatermark.html#afae57d5f76c3f9c813a56cc39dd10604">init</a>();</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00127"></a><span class="lineno"><a class="line" href="classWatermark.html#ac52684304e9900866b0e890ca68257f1">  127</a></span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classWatermark.html#ac52684304e9900866b0e890ca68257f1">isSet</a>(){</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keywordflow">if</span>( _isSet ) <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;  }</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;};</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classWatermark_html_afae57d5f76c3f9c813a56cc39dd10604"><div class="ttname"><a href="classWatermark.html#afae57d5f76c3f9c813a56cc39dd10604">Watermark::init</a></div><div class="ttdeci">void init()</div><div class="ttdoc">Initialize our watermark image. </div></div>
<div class="ttc" id="classWatermark_html_a7fe56ff07579dc3b432dc6daa699f25c"><div class="ttname"><a href="classWatermark.html#a7fe56ff07579dc3b432dc6daa699f25c">Watermark::getProbability</a></div><div class="ttdeci">float getProbability()</div><div class="ttdoc">Return watermark probability. </div><div class="ttdef"><b>Definition:</b> Watermark.h:121</div></div>
<div class="ttc" id="classWatermark_html_ac52684304e9900866b0e890ca68257f1"><div class="ttname"><a href="classWatermark.html#ac52684304e9900866b0e890ca68257f1">Watermark::isSet</a></div><div class="ttdeci">bool isSet()</div><div class="ttdoc">Determine whether a watermark has been specified. </div><div class="ttdef"><b>Definition:</b> Watermark.h:127</div></div>
<div class="ttc" id="classWatermark_html_a274317a27cb523b519b28be6d622f2bf"><div class="ttname"><a href="classWatermark.html#a274317a27cb523b519b28be6d622f2bf">Watermark::Watermark</a></div><div class="ttdeci">Watermark()</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> Watermark.h:76</div></div>
<div class="ttc" id="classWatermark_html_af18c0054dceec80c7ab1a5d2c8d10967"><div class="ttname"><a href="classWatermark.html#af18c0054dceec80c7ab1a5d2c8d10967">Watermark::getImage</a></div><div class="ttdeci">std::string getImage()</div><div class="ttdoc">Return watermark image path. </div><div class="ttdef"><b>Definition:</b> Watermark.h:115</div></div>
<div class="ttc" id="classWatermark_html_a497b6518f7470e5048bb6be853d4f85e"><div class="ttname"><a href="classWatermark.html#a497b6518f7470e5048bb6be853d4f85e">Watermark::getOpacity</a></div><div class="ttdeci">float getOpacity()</div><div class="ttdoc">Return watermark opacity. </div><div class="ttdef"><b>Definition:</b> Watermark.h:118</div></div>
<div class="ttc" id="classWatermark_html"><div class="ttname"><a href="classWatermark.html">Watermark</a></div><div class="ttdoc">Watermark class. </div><div class="ttdef"><b>Definition:</b> Watermark.h:41</div></div>
<div class="ttc" id="classWatermark_html_a32e861948948b0ef070cb1a60439f58f"><div class="ttname"><a href="classWatermark.html#a32e861948948b0ef070cb1a60439f58f">Watermark::apply</a></div><div class="ttdeci">void apply(void *data, unsigned int width, unsigned int height, unsigned int channels, unsigned int bpc)</div><div class="ttdoc">Apply the watermark to a data buffer. </div></div>
<div class="ttc" id="classWatermark_html_a5e484cce31c3d67dceb751df8e48a8ef"><div class="ttname"><a href="classWatermark.html#a5e484cce31c3d67dceb751df8e48a8ef">Watermark::~Watermark</a></div><div class="ttdeci">~Watermark()</div><div class="ttdoc">Destructor. </div><div class="ttdef"><b>Definition:</b> Watermark.h:101</div></div>
<div class="ttc" id="classWatermark_html_a96a43470184588ea58d0b529213a7ec7"><div class="ttname"><a href="classWatermark.html#a96a43470184588ea58d0b529213a7ec7">Watermark::Watermark</a></div><div class="ttdeci">Watermark(const std::string &amp;file, float opacity, float probability)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> Watermark.h:88</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><b>Watermark.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.14 </li>
  </ul>
</div>
</body>
</html>
